<?php
/********************************************************************************/
/*    Smart Extranet  2004-2010. All right reserved. www.smart-extranet.com    */
/********************************************************************************/

	function rotate($string, $n) 
	{
    $length = strlen($string);
    $result = '';
   
    for($i = 0; $i < $length; $i++) {
        $ascii = ord($string{$i});
       
        $rotated = $ascii;
       
        if ($ascii > 44 && $ascii < 123) {
            $rotated += $n;
            $rotated > 122 && $rotated += -122 + 44;
            $rotated < 45 && $rotated += -44 + 122;
        } 
       
        $result .= chr($rotated);
    }
   
    return $result;
	}
	
	function activate_key($key)
	{
		$error = 0;
		$msg = '';

		if (substr($key,0,2) != '@@' OR substr(strrev($key),0,2) != '3a')
		{
			$error++;
			$msg .= '#E001';
			$infos_key['msg'] = $msg;
			return $infos_key;
		}
		else
		{
			$key = substr($key,2,strlen($key)-4);
			$licence = substr($key,0,10);
			$licence_use = substr($key,10,1);
			$extranet = substr($key,11,4);
			if (strtolower($extranet) == "1w2z")
			{
				$extranet = 0;
			}
			else
			{
				$extranet = str_replace("z","",strtolower($extranet));
				$extranet = base_convert($extranet, 16, 10);
			}
			$url = substr($key,15);
			$url = rotate($url, (0-($licence_use*4)));
			$infos_key['msg'] = 'ok';
			$infos_key['licence'] = $licence;
			$infos_key['licence_use'] = $licence_use;
			$infos_key['extranet'] = $extranet;
			$infos_key['url'] = $url;
			return $infos_key;
		}
		
	}
	
	function gen_licence()
{
	$gen_licence = "";
	$possible = "123456789ABCDEFGHIJKLMNPQRSTUVWXYZ"; 

	$length=8;
	$i = 0; 
	while ($i < $length){ 
		$char = substr($possible, mt_rand(0, strlen($possible)-1), 1);
		if (!strstr($gen_licence, $char)) 
		{ 
			$gen_licence .= $char;
			$i++;
		}
	}	
	return $gen_licence;
}
	
?>
